<?php
# ---------------------------------------------------------------------------------

/**
* @version v 1.5 for Joomla! 1.5.x
* @author: Gero Zahn, gero@gerozahn.de www.gerozahn.de/bot_gznoclicktoactivate
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.*/

/*

	NOTE:

		This is a legacy implementation of the gznoclicktoactivate mambot - i.e.
		not much more than the original mambot tuned up to Joomla! 1.5.

		As this "registerEvent(...)" implementation will become deprecated
		sooner or later, there will of course be a true, more efficient
		"class plgContentGzNoClickToActivate extends JPlugin" implementation.

		But sorry - not today ...

*/

# ---------------------------------------------------------------------------------

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onBeforeDisplayContent', 'plhgznoclicktoactivate_legacy' );

# ---------------------------------------------------------------------------------

function plhgznoclicktoactivate_legacy( &$row, $mask=0, $page=0 ) {

	# All tag areas or tags to be processed. Important: Start with <object ...>...</object> areas
	# as it could contain an <embed ...>..</embed> area or (perhaps) an unclosed <embed ...> tags

	$tags=array('`<object[^>]*>(.*)</object>`isU', # <object ...>...</object> areas
							'`<applet[^>]*>(.*)</applet>`isU', # <applet ...>...</applet> areas
							'`<embed[^>]*>(.*)</embed>`isU',	# <embed ...>..</embed> areas
							'`<embed[^>]*>`isU');							# single, unclosed <embed ...> tags outsite object areas

	$replacements=array(); # Storage for the elements found to be processed

	foreach(array_keys($tags) as $idx) { # Handle all kings of tag areas and tags, one by one

		$tmptags=array(); # Storage for the found occurrences
		preg_match_all($tags[$idx],$row->text,$tmptags); # And here they are

		if ($tmptags) { # Found some?

			foreach(array_keys($tmptags[0]) as $secidx) { # Deal with them, one by one

				# We have to move them apart -- especially <object ...>...</object> areas with an internal
				# <embed ...>..</embed> area or an unclosed <embed ...> tag -- otherwise they'd be found again.

				$tagval=$tmptags[0][$secidx]; # This is the current occurrence to be processed later on
				$tagkey="replacetag_".$idx."_".$secidx."_"; # Temporarily replace it by "replacetag_x_y_"
				# ... where x is 0..3 (object/applet/embed/s.embed) and y is the corresponding number.
				# The "_" suffix is necessary as otherwise "replacetag_x_10" would be replaced by "replacetag_x_1" later

				$replacements[$tagkey]=$tagval; # Store the occurrence beside it's unique key ...
				$row->text=str_replace($tagval,$tagkey,$row->text); # ... and actually replace the occurrence with the key
			}
		}

		unset($tmptags); # A bit of dirty work

	}

	$fname=JURI::base()."plugins/content/gznoclicktoactivate.js"; # That's the URL of the embedder script

	foreach($replacements as $tagkey => $tagval) { # Handle all occurrences, one by one

		$jsval=addslashes($tagval); # Handle special characters properly
		$jsval=str_replace(chr(13),"",$jsval); # remove CRs - all in one line
		$jsval=str_replace(chr(10),"",$jsval); # remove LFs - all in one line

		# 1. Embed that tiny little external JS to work as actual embedder.
		# 2. Embed the original occurrence inside a JS variable -- 
		# 3. Call the tiny little embedder to dynamically output the variable
		# 4. Embed the original, unchanged occurrence in a <noscript>...</noscript> area as fall-back
		$jsval= "<script src=\"$fname\" type=\"text/javascript\"></script>\n".
						"<script language=\"JavaScript\">\n".
						"<!--\n".
						"var jsval = '$jsval';\n".
#						"//document.write(jsval);". # This doesn't work as it's an internal document.write(...)
						"writethis(jsval);". # So: Use the external one-liner function to perform the trick
						"//-->\n".
						"</script>\n".
						"<noscript>$tagval</noscript>";

		# The original occurrence has been replaced with its unique "key" beforehanded,
		# now replace this stored key with is JS wrapper and noscript fallback.
		$row->text=str_replace($tagkey,$jsval,$row->text);

	}

	unset($replacements); # A bit of dirty work

}

# ---------------------------------------------------------------------------------

?>

